<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBillCostStore } from '@/stores/billcost'
import { useBranchStore } from '@/stores/branch'
import { useTypebillcostStore } from '@/stores/typebillcost'
import { useUserStore } from '@/stores/user'
import { computed, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const typebillcostStore = useTypebillcostStore()
const branchStore = useBranchStore()
const billcostStore = useBillCostStore()
const authStore = useAuthStore()
const UserStore = useUserStore()
const loading = ref(false)
const form = ref(false)
const refform = ref<VForm | null>(null)
const nototal = ref(false)
const nouser = ref(false)
const nobranch = ref(false)
const noall = ref(false)
const nodate = ref(false)
const notime = ref(false)
const notypebillcost = ref(false)
const currentUser = computed(() => authStore.getCurrentUser())
function onSubmit() {}

const isValidDate = (dateString: string) => {
  // ตรวจสอบว่าวันที่ตรงกับรูปแบบ YYYY-MM-DD และเป็นตัวเลขหรือไม่
  const regex = /^\d{4}-\d{2}-\d{2}$/
  return regex.test(dateString)
}

const isValidTime = (timeString: string) => {
  // ตรวจสอบว่าเวลาตรงกับรูปแบบ HH:MM:SS และเป็นตัวเลขหรือไม่
  const regex = /^\d{2}:\d{2}:\d{2}$/
  return regex.test(timeString)
}

const validateBillcostTotal = (v: number) => {
  if (v === null) return 'Field is required '
  const num = Number(v)
  return (Number.isFinite(num) && num > 0) || 'Number must be more than 0'
}
const filteredBranches = computed(() => {
  const allUsers = UserStore.users
  if (!currentUser.value) {
    // หาข้อมูลผู้ใช้ปัจจุบัน
    return null
  }
  const currentUserData = allUsers.find((user) => user.id === currentUser.value?.id)
  if (!currentUserData) {
    // ตรวจสอบว่าพบข้อมูลผู้ใช้ปัจจุบันหรือไม่
    return null
  }
  return currentUserData.branch // คืนค่า branch ของผู้ใช้ปัจจุบัน
})
const filteredUsers = computed(() => {
  const allUsers = UserStore.users

  if (!currentUser.value) {
    return null
  }

  const currentUserData = allUsers.find((user) => user.id === currentUser.value?.id)

  if (!currentUserData) {
    return null
  }

  // กรองรายการผู้ใช้ตามสาขาของผู้ใช้ปัจจุบัน
  const usersWithMatchingBranch = allUsers.filter(
    (user) => user.branch?.id === currentUserData.branch?.id
  )

  return usersWithMatchingBranch
})

const save = () => {
  if (
    !billcostStore.editedbillCost.typebillcost &&
    billcostStore.editedbillCost.billtotal <= 0 &&
    !billcostStore.editedbillCost.user &&
    !isValidDate(billcostStore.editedbillCost.date) &&
    !isValidTime(billcostStore.editedbillCost.time) &&
    !billcostStore.editedbillCost.branch
  ) {
    noall.value = true
  } else if (!billcostStore.editedbillCost.typebillcost) {
    notypebillcost.value = true
  } else if (!billcostStore.editedbillCost.user) {
    nouser.value = true
  } else if (!isValidDate(billcostStore.editedbillCost.date)) {
    nodate.value = true
  } else if (!isValidTime(billcostStore.editedbillCost.time)) {
    notime.value = true
  } else if (billcostStore.editedbillCost.billtotal <= 0) {
    nototal.value = true
  } else if (!billcostStore.editedbillCost.branch) {
    nobranch.value = true
  } else if (
    billcostStore.editedbillCost.typebillcost &&
    billcostStore.editedbillCost.billtotal > 0 &&
    billcostStore.editedbillCost.user &&
    isValidDate(billcostStore.editedbillCost.date) &&
    isValidTime(billcostStore.editedbillCost.time) &&
    billcostStore.editedbillCost.branch
  ) {
    billcostStore.savebillcost()
    billcostStore.closeDialogEdit()
  }
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="billcostStore.dialogEdit" persistent width="1024">
      <v-card style="border: #fe0000 solid 2px; border-radius: 50px">
        <v-card-title style="margin-left: 30px; padding: 20px">
          <span class="text-h5">EDIT BILL COST</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <v-combobox
                    v-model="billcostStore.editedbillCost.typebillcost"
                    :items="typebillcostStore.typebillcosts"
                    item-title="name"
                    item-value="id"
                    label="TypeBill"
                    :return-object="true"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="4" v-if="authStore.getCurrentUser()?.role === 'Owner'">
                  <v-combobox
                    v-model="billcostStore.editedbillCost.user"
                    :readonly="loading"
                    :items="UserStore.users"
                    item-title="fullName"
                    item-value="id"
                    label="User"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col
                  cols="12"
                  sm="12"
                  md="4"
                  v-if="authStore.getCurrentUser()?.role === 'Manager'"
                >
                  <v-combobox
                    v-model="billcostStore.editedbillCost.user"
                    :items="UserStore.users"
                    :readonly="loading"
                    item-title="fullName"
                    item-value="id"
                    label="User"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="4" v-if="authStore.getCurrentUser()?.role === 'Staff'">
                  <v-combobox
                    v-model="billcostStore.editedbillCost.user"
                    :items="[authStore.getCurrentUser()]"
                    item-title="fullName"
                    item-value="id"
                    label="User"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="billcostStore.editedbillCost.date"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="date"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="billcostStore.editedbillCost.time"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="time"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="billcostStore.editedbillCost.billtotal"
                    :readonly="loading"
                    :rules="[validateBillcostTotal]"
                    class="mb-2"
                    clearable
                    label="Total"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="4" v-if="authStore.getCurrentUser()?.role === 'Owner'">
                  <v-combobox
                    v-model="billcostStore.editedbillCost.branch"
                    :items="branchStore.branchs"
                    item-title="Address"
                    item-value="id"
                    label="Select branch"
                    :return-object="true"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-col
                  cols="12"
                  sm="12"
                  md="4"
                  v-if="
                    authStore.getCurrentUser()?.role === 'Manager' ||
                    authStore.getCurrentUser()?.role === 'Staff'
                  "
                >
                  <v-combobox
                    v-model="billcostStore.editedbillCost.branch"
                    :items="[authStore.getCurrentUser()?.branch]"
                    item-title="Address"
                    item-value="id"
                    label="Select branch"
                    :return-object="true"
                    :rules="[(v) => !!v || 'Field is required']"
                  ></v-combobox>
                </v-col>

                <v-divider :thickness="2"></v-divider>
                <v-col cols="12" sm="12" md="4" style="padding: 5%">
                  <v-file-input
                    v-model="billcostStore.editedbillCost.files"
                    :rules="[
                      (value) => {
                        return (
                          !value ||
                          !value.length ||
                          value[0].size < 2000000 ||
                          'Avatar size should be less than 2 MB!'
                        )
                      }
                    ]"
                    accept="image/png, image/jpeg"
                    label="Avatar"
                    placeholder="Pick an avatar"
                    prepend-icon="mdi-image-multiple"
                  >
                  </v-file-input>
                </v-col>
                <v-col cols="12" sm="12" md="2">
                  <v-img
                    :src="
                      'http://localhost:3000/images/billcosts/' + billcostStore.editedbillCost.image
                    "
                    height="200"
                    width="200"
                  ></v-img>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="billcostStore.closeDialogEdit()">
            Close
          </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()" style="margin-right: 30px">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <template>
    <v-dialog v-model="nototal" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter the amount.</v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="nouser" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter User. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="nobranch" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Branch. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="noall" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Field is required. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="notypebillcost" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Typebillcost. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="nodate" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Date. YYYY-MM-DD </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="notime" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Time. HH:MM:SS </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
  </template>
</template>
